package de.humance.eco.profile.model.impl;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;
import com.liferay.portlet.expando.util.ExpandoBridgeFactoryUtil;

import de.humance.eco.profile.model.VehicleAttributeDefinitionResource;
import de.humance.eco.profile.model.VehicleAttributeDefinitionResourceModel;

import java.io.Serializable;

import java.sql.Types;

import java.util.HashMap;
import java.util.Map;

/**
 * The base model implementation for the VehicleAttributeDefinitionResource service. Represents a row in the &quot;Profile_VehicleAttributeDefinitionResource&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link de.humance.eco.profile.model.VehicleAttributeDefinitionResourceModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link VehicleAttributeDefinitionResourceImpl}.
 * </p>
 *
 * @author Humance
 * @see VehicleAttributeDefinitionResourceImpl
 * @see de.humance.eco.profile.model.VehicleAttributeDefinitionResource
 * @see de.humance.eco.profile.model.VehicleAttributeDefinitionResourceModel
 * @generated
 */
public class VehicleAttributeDefinitionResourceModelImpl extends BaseModelImpl<VehicleAttributeDefinitionResource>
    implements VehicleAttributeDefinitionResourceModel {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this class directly. All methods that expect a vehicle attribute definition resource model instance should use the {@link de.humance.eco.profile.model.VehicleAttributeDefinitionResource} interface instead.
     */
    public static final String TABLE_NAME = "Profile_VehicleAttributeDefinitionResource";
    public static final Object[][] TABLE_COLUMNS = {
            { "vehicleAttributeDefinitionResourceId", Types.BIGINT },
            { "vehicleAttributeDefinitionId", Types.BIGINT },
            { "country", Types.VARCHAR },
            { "language", Types.VARCHAR },
            { "title", Types.VARCHAR },
            { "unit", Types.VARCHAR }
        };
    public static final String TABLE_SQL_CREATE = "create table Profile_VehicleAttributeDefinitionResource (vehicleAttributeDefinitionResourceId LONG not null primary key,vehicleAttributeDefinitionId LONG,country VARCHAR(75) null,language VARCHAR(75) null,title VARCHAR(500) null,unit VARCHAR(255) null)";
    public static final String TABLE_SQL_DROP = "drop table Profile_VehicleAttributeDefinitionResource";
    public static final String ORDER_BY_JPQL = " ORDER BY vehicleAttributeDefinitionResource.vehicleAttributeDefinitionId ASC, vehicleAttributeDefinitionResource.country ASC, vehicleAttributeDefinitionResource.language ASC";
    public static final String ORDER_BY_SQL = " ORDER BY Profile_VehicleAttributeDefinitionResource.vehicleAttributeDefinitionId ASC, Profile_VehicleAttributeDefinitionResource.country ASC, Profile_VehicleAttributeDefinitionResource.language ASC";
    public static final String DATA_SOURCE = "liferayDataSource";
    public static final String SESSION_FACTORY = "liferaySessionFactory";
    public static final String TX_MANAGER = "liferayTransactionManager";
    public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.entity.cache.enabled.de.humance.eco.profile.model.VehicleAttributeDefinitionResource"),
            true);
    public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.finder.cache.enabled.de.humance.eco.profile.model.VehicleAttributeDefinitionResource"),
            true);
    public static final boolean COLUMN_BITMASK_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.column.bitmask.enabled.de.humance.eco.profile.model.VehicleAttributeDefinitionResource"),
            true);
    public static long COUNTRY_COLUMN_BITMASK = 1L;
    public static long LANGUAGE_COLUMN_BITMASK = 2L;
    public static long VEHICLEATTRIBUTEDEFINITIONID_COLUMN_BITMASK = 4L;
    public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(com.liferay.util.service.ServiceProps.get(
                "lock.expiration.time.de.humance.eco.profile.model.VehicleAttributeDefinitionResource"));
    private static ClassLoader _classLoader = VehicleAttributeDefinitionResource.class.getClassLoader();
    private static Class<?>[] _escapedModelInterfaces = new Class[] {
            VehicleAttributeDefinitionResource.class
        };
    private long _vehicleAttributeDefinitionResourceId;
    private long _vehicleAttributeDefinitionId;
    private long _originalVehicleAttributeDefinitionId;
    private boolean _setOriginalVehicleAttributeDefinitionId;
    private String _country;
    private String _originalCountry;
    private String _language;
    private String _originalLanguage;
    private String _title;
    private String _unit;
    private long _columnBitmask;
    private VehicleAttributeDefinitionResource _escapedModel;

    public VehicleAttributeDefinitionResourceModelImpl() {
    }

    @Override
    public long getPrimaryKey() {
        return _vehicleAttributeDefinitionResourceId;
    }

    @Override
    public void setPrimaryKey(long primaryKey) {
        setVehicleAttributeDefinitionResourceId(primaryKey);
    }

    @Override
    public Serializable getPrimaryKeyObj() {
        return _vehicleAttributeDefinitionResourceId;
    }

    @Override
    public void setPrimaryKeyObj(Serializable primaryKeyObj) {
        setPrimaryKey(((Long) primaryKeyObj).longValue());
    }

    @Override
    public Class<?> getModelClass() {
        return VehicleAttributeDefinitionResource.class;
    }

    @Override
    public String getModelClassName() {
        return VehicleAttributeDefinitionResource.class.getName();
    }

    @Override
    public Map<String, Object> getModelAttributes() {
        Map<String, Object> attributes = new HashMap<String, Object>();

        attributes.put("vehicleAttributeDefinitionResourceId",
            getVehicleAttributeDefinitionResourceId());
        attributes.put("vehicleAttributeDefinitionId",
            getVehicleAttributeDefinitionId());
        attributes.put("country", getCountry());
        attributes.put("language", getLanguage());
        attributes.put("title", getTitle());
        attributes.put("unit", getUnit());

        return attributes;
    }

    @Override
    public void setModelAttributes(Map<String, Object> attributes) {
        Long vehicleAttributeDefinitionResourceId = (Long) attributes.get(
                "vehicleAttributeDefinitionResourceId");

        if (vehicleAttributeDefinitionResourceId != null) {
            setVehicleAttributeDefinitionResourceId(vehicleAttributeDefinitionResourceId);
        }

        Long vehicleAttributeDefinitionId = (Long) attributes.get(
                "vehicleAttributeDefinitionId");

        if (vehicleAttributeDefinitionId != null) {
            setVehicleAttributeDefinitionId(vehicleAttributeDefinitionId);
        }

        String country = (String) attributes.get("country");

        if (country != null) {
            setCountry(country);
        }

        String language = (String) attributes.get("language");

        if (language != null) {
            setLanguage(language);
        }

        String title = (String) attributes.get("title");

        if (title != null) {
            setTitle(title);
        }

        String unit = (String) attributes.get("unit");

        if (unit != null) {
            setUnit(unit);
        }
    }

    @Override
    public long getVehicleAttributeDefinitionResourceId() {
        return _vehicleAttributeDefinitionResourceId;
    }

    @Override
    public void setVehicleAttributeDefinitionResourceId(
        long vehicleAttributeDefinitionResourceId) {
        _vehicleAttributeDefinitionResourceId = vehicleAttributeDefinitionResourceId;
    }

    @Override
    public long getVehicleAttributeDefinitionId() {
        return _vehicleAttributeDefinitionId;
    }

    @Override
    public void setVehicleAttributeDefinitionId(
        long vehicleAttributeDefinitionId) {
        _columnBitmask = -1L;

        if (!_setOriginalVehicleAttributeDefinitionId) {
            _setOriginalVehicleAttributeDefinitionId = true;

            _originalVehicleAttributeDefinitionId = _vehicleAttributeDefinitionId;
        }

        _vehicleAttributeDefinitionId = vehicleAttributeDefinitionId;
    }

    public long getOriginalVehicleAttributeDefinitionId() {
        return _originalVehicleAttributeDefinitionId;
    }

    @Override
    public String getCountry() {
        if (_country == null) {
            return StringPool.BLANK;
        } else {
            return _country;
        }
    }

    @Override
    public void setCountry(String country) {
        _columnBitmask = -1L;

        if (_originalCountry == null) {
            _originalCountry = _country;
        }

        _country = country;
    }

    public String getOriginalCountry() {
        return GetterUtil.getString(_originalCountry);
    }

    @Override
    public String getLanguage() {
        if (_language == null) {
            return StringPool.BLANK;
        } else {
            return _language;
        }
    }

    @Override
    public void setLanguage(String language) {
        _columnBitmask = -1L;

        if (_originalLanguage == null) {
            _originalLanguage = _language;
        }

        _language = language;
    }

    public String getOriginalLanguage() {
        return GetterUtil.getString(_originalLanguage);
    }

    @Override
    public String getTitle() {
        if (_title == null) {
            return StringPool.BLANK;
        } else {
            return _title;
        }
    }

    @Override
    public void setTitle(String title) {
        _title = title;
    }

    @Override
    public String getUnit() {
        if (_unit == null) {
            return StringPool.BLANK;
        } else {
            return _unit;
        }
    }

    @Override
    public void setUnit(String unit) {
        _unit = unit;
    }

    public long getColumnBitmask() {
        return _columnBitmask;
    }

    @Override
    public ExpandoBridge getExpandoBridge() {
        return ExpandoBridgeFactoryUtil.getExpandoBridge(0,
            VehicleAttributeDefinitionResource.class.getName(), getPrimaryKey());
    }

    @Override
    public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
        ExpandoBridge expandoBridge = getExpandoBridge();

        expandoBridge.setAttributes(serviceContext);
    }

    @Override
    public VehicleAttributeDefinitionResource toEscapedModel() {
        if (_escapedModel == null) {
            _escapedModel = (VehicleAttributeDefinitionResource) ProxyUtil.newProxyInstance(_classLoader,
                    _escapedModelInterfaces, new AutoEscapeBeanHandler(this));
        }

        return _escapedModel;
    }

    @Override
    public Object clone() {
        VehicleAttributeDefinitionResourceImpl vehicleAttributeDefinitionResourceImpl =
            new VehicleAttributeDefinitionResourceImpl();

        vehicleAttributeDefinitionResourceImpl.setVehicleAttributeDefinitionResourceId(getVehicleAttributeDefinitionResourceId());
        vehicleAttributeDefinitionResourceImpl.setVehicleAttributeDefinitionId(getVehicleAttributeDefinitionId());
        vehicleAttributeDefinitionResourceImpl.setCountry(getCountry());
        vehicleAttributeDefinitionResourceImpl.setLanguage(getLanguage());
        vehicleAttributeDefinitionResourceImpl.setTitle(getTitle());
        vehicleAttributeDefinitionResourceImpl.setUnit(getUnit());

        vehicleAttributeDefinitionResourceImpl.resetOriginalValues();

        return vehicleAttributeDefinitionResourceImpl;
    }

    @Override
    public int compareTo(
        VehicleAttributeDefinitionResource vehicleAttributeDefinitionResource) {
        int value = 0;

        if (getVehicleAttributeDefinitionId() < vehicleAttributeDefinitionResource.getVehicleAttributeDefinitionId()) {
            value = -1;
        } else if (getVehicleAttributeDefinitionId() > vehicleAttributeDefinitionResource.getVehicleAttributeDefinitionId()) {
            value = 1;
        } else {
            value = 0;
        }

        if (value != 0) {
            return value;
        }

        value = getCountry()
                    .compareToIgnoreCase(vehicleAttributeDefinitionResource.getCountry());

        if (value != 0) {
            return value;
        }

        value = getLanguage()
                    .compareToIgnoreCase(vehicleAttributeDefinitionResource.getLanguage());

        if (value != 0) {
            return value;
        }

        return 0;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }

        if (!(obj instanceof VehicleAttributeDefinitionResource)) {
            return false;
        }

        VehicleAttributeDefinitionResource vehicleAttributeDefinitionResource = (VehicleAttributeDefinitionResource) obj;

        long primaryKey = vehicleAttributeDefinitionResource.getPrimaryKey();

        if (getPrimaryKey() == primaryKey) {
            return true;
        } else {
            return false;
        }
    }

    @Override
    public int hashCode() {
        return (int) getPrimaryKey();
    }

    @Override
    public void resetOriginalValues() {
        VehicleAttributeDefinitionResourceModelImpl vehicleAttributeDefinitionResourceModelImpl =
            this;

        vehicleAttributeDefinitionResourceModelImpl._originalVehicleAttributeDefinitionId = vehicleAttributeDefinitionResourceModelImpl._vehicleAttributeDefinitionId;

        vehicleAttributeDefinitionResourceModelImpl._setOriginalVehicleAttributeDefinitionId = false;

        vehicleAttributeDefinitionResourceModelImpl._originalCountry = vehicleAttributeDefinitionResourceModelImpl._country;

        vehicleAttributeDefinitionResourceModelImpl._originalLanguage = vehicleAttributeDefinitionResourceModelImpl._language;

        vehicleAttributeDefinitionResourceModelImpl._columnBitmask = 0;
    }

    @Override
    public CacheModel<VehicleAttributeDefinitionResource> toCacheModel() {
        VehicleAttributeDefinitionResourceCacheModel vehicleAttributeDefinitionResourceCacheModel =
            new VehicleAttributeDefinitionResourceCacheModel();

        vehicleAttributeDefinitionResourceCacheModel.vehicleAttributeDefinitionResourceId = getVehicleAttributeDefinitionResourceId();

        vehicleAttributeDefinitionResourceCacheModel.vehicleAttributeDefinitionId = getVehicleAttributeDefinitionId();

        vehicleAttributeDefinitionResourceCacheModel.country = getCountry();

        String country = vehicleAttributeDefinitionResourceCacheModel.country;

        if ((country != null) && (country.length() == 0)) {
            vehicleAttributeDefinitionResourceCacheModel.country = null;
        }

        vehicleAttributeDefinitionResourceCacheModel.language = getLanguage();

        String language = vehicleAttributeDefinitionResourceCacheModel.language;

        if ((language != null) && (language.length() == 0)) {
            vehicleAttributeDefinitionResourceCacheModel.language = null;
        }

        vehicleAttributeDefinitionResourceCacheModel.title = getTitle();

        String title = vehicleAttributeDefinitionResourceCacheModel.title;

        if ((title != null) && (title.length() == 0)) {
            vehicleAttributeDefinitionResourceCacheModel.title = null;
        }

        vehicleAttributeDefinitionResourceCacheModel.unit = getUnit();

        String unit = vehicleAttributeDefinitionResourceCacheModel.unit;

        if ((unit != null) && (unit.length() == 0)) {
            vehicleAttributeDefinitionResourceCacheModel.unit = null;
        }

        return vehicleAttributeDefinitionResourceCacheModel;
    }

    @Override
    public String toString() {
        StringBundler sb = new StringBundler(13);

        sb.append("{vehicleAttributeDefinitionResourceId=");
        sb.append(getVehicleAttributeDefinitionResourceId());
        sb.append(", vehicleAttributeDefinitionId=");
        sb.append(getVehicleAttributeDefinitionId());
        sb.append(", country=");
        sb.append(getCountry());
        sb.append(", language=");
        sb.append(getLanguage());
        sb.append(", title=");
        sb.append(getTitle());
        sb.append(", unit=");
        sb.append(getUnit());
        sb.append("}");

        return sb.toString();
    }

    @Override
    public String toXmlString() {
        StringBundler sb = new StringBundler(22);

        sb.append("<model><model-name>");
        sb.append(
            "de.humance.eco.profile.model.VehicleAttributeDefinitionResource");
        sb.append("</model-name>");

        sb.append(
            "<column><column-name>vehicleAttributeDefinitionResourceId</column-name><column-value><![CDATA[");
        sb.append(getVehicleAttributeDefinitionResourceId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>vehicleAttributeDefinitionId</column-name><column-value><![CDATA[");
        sb.append(getVehicleAttributeDefinitionId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>country</column-name><column-value><![CDATA[");
        sb.append(getCountry());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>language</column-name><column-value><![CDATA[");
        sb.append(getLanguage());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>title</column-name><column-value><![CDATA[");
        sb.append(getTitle());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>unit</column-name><column-value><![CDATA[");
        sb.append(getUnit());
        sb.append("]]></column-value></column>");

        sb.append("</model>");

        return sb.toString();
    }
}
